/*
 * Copyright (C) 2012 - Michael Baudin
 *
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 */

#include "cdflib.h"
#include "cdflib_private.h"

int cdflib_frnd(double v1, double v2, double *x)
{
	double d__1;
	static double xden, xnum;
	int status;
	status=cdflib_fCheckParams("cdflib_fpdf",v1, v2);
	if (status!=CDFLIB_OK)
	{
		return status;
	}
	d__1 = v1 / 2.;
	xnum = cdflib_sgamma(d__1) * 2. / v1;
	d__1 = v2 / 2.;
	xden = cdflib_sgamma(d__1) * 2. / v2;
	*x = xnum / xden;
	return CDFLIB_OK;
}

