/*
 * Copyright (C) 2012 - Michael Baudin
 *
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 */

#include <math.h>

#include "cdflib.h"
#include "cdflib_private.h"

int cdflib_gennch(double df, double xnonc, double *x)
{
	double ret_val, d__1, d__2;

	// TODO : check the arguments

	/*     JJV changed these to call cdflib_sgamma and cdflib_snorm directly */
	/*     JJV changed abort to df < 1, and added case: df = 1 */
	/*     JJV changed this to call cdflib_sgamma and cdflib_snorm directly */
	if (df >= 1.000001) {
		goto L20;
	}
	/*     JJV case DF = 1.0 */
	/* Computing 2nd power */
	d__1 = cdflib_snorm() + sqrt(xnonc);
	ret_val = d__1 * d__1;
	goto L30;
	/*     JJV case DF > 1.0 */
L20:
	d__1 = (df - 1.) / 2.;
	/* Computing 2nd power */
	d__2 = cdflib_snorm() + sqrt(xnonc);
	ret_val = cdflib_sgamma(d__1) * 2. + d__2 * d__2;
L30:
	*x=ret_val;
	return CDFLIB_OK;
}

