/*
 * Copyright (C) 2012 - Michael Baudin
 *
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 */

#include "cdflib.h"
#include "cdflib_private.h"

int cdflib_ignnbn(int n, double p, int *x)
{
	static double a, r__, y;
	int status;
	double poissx;

	// TODO : check the arguments

	/*     JJV changed to call cdflib_sgamma directly */

	/*     Check Arguments */
	/*     JJV changed argumnet checker to abort if N <= 0 */
	/*     See Rand,c */
	/*     Generate Y, a random gamma (n,(1-p)/p) variable */
	/*     JJV Note: the above parametrization is consistent with Devroye, */
	/*     JJV       but gamma (p/(1-p),n) is the equivalent in our code */
	r__ = (double) (n);
	a = p / (1. - p);
	y = cdflib_sgamma(r__) / a;
	/*     Generate a random Poisson(y) variable */
	// TODO : check status
	status = cdflib_poissrnd(y, &poissx);
	*x=(int)poissx;
	return CDFLIB_OK;
}

