/*
 * Copyright (C) 2012 - Michael Baudin
 *
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 */

#include "cdflib.h"
#include "cdflib_private.h"

#include <math.h>

int cdflib_trnd(double v, double *x)
{
	double Z;
	double C;
	int status;
	status=cdflib_tCheckParams("cdflib_trnd",v);
	if (status!=CDFLIB_OK)
	{
		return status;
	}
	Z=cdflib_snorm();
	status=cdflib_chi2rnd(v,&C);
	if (status!=CDFLIB_OK)
	{
		return status;
	}
	*x=Z/sqrt(C/v);
	return CDFLIB_OK;
}

